
#include "f2c.h"

/* Common Block Declarations */

struct {
    doublereal wc1, wc2, wc3, hd2, hd4, hold;
    integer lasn;
} com70d_;

#define com70d_1 com70d_

/* Subroutine */ int de55d_c(U_fp f, integer *m, doublereal *xn, doublereal *
	yn, doublereal *xk, integer *k, integer *iniapr, integer *imax,
	integer *iordy, doublereal *h__, doublereal *y, integer *nx,
	doublereal *xs, doublereal *ay, doublereal *ady, doublereal *rab)
{
    /* System generated locals */
    integer ay_dim1, ay_offset, ady_dim1, ady_offset, i__1, i__2;
    doublereal d__1;

    /* Builtin functions */
    double d_sign(doublereal *, doublereal *);

    /* Local variables */
    static integer j, l;
    static doublereal x, h1;
    static integer i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11;
    static doublereal hs;
    static integer jt, kp1, kp2;
    static logical bul;
    static integer jtp;
    extern /* Subroutine */ int de44d_c(U_fp, integer *, integer *, integer *,
	    integer *, integer *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *);
    static integer nxay, imax0, nxady, nxadyp, jstart;

    /* Parameter adjustments */
    ady_dim1 = *m;
    ady_offset = 1 + ady_dim1;
    ady -= ady_offset;
    ay_dim1 = *m;
    ay_offset = 1 + ay_dim1;
    ay -= ay_offset;
    --y;
    --yn;
    --xs;
    --rab;

    /* Function Body */
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L10: */
	y[l] = yn[l];
    }
    *nx = 0;
    xs[1] = *xn;
    if (*xn == *xk) {
	goto L100;
    }
    d__1 = *xk - *xn;
    *h__ = d_sign(h__, &d__1);
    bul = FALSE_;
    jstart = 0;
    imax0 = *imax;
    if (*iniapr > 1 && *imax <= *k) {
	imax0 = *k + *iniapr - 1;
    }
    kp1 = *k + 1;
    kp2 = *k + 2;
    nxay = 1;
    nxady = 1;
    x = *xn;
    i0 = kp1;
    i1 = i0 + kp1;
    i2 = i1 + *k;
    i3 = i2 + *k;
    i4 = i3 + *k;
    i5 = i4 + *k * *k;
    i6 = i5 + kp2 * (*k - 1) / 2;
    i7 = i6 + (*k + 3) * *k / 2;
    i8 = i7 + 1;
    i9 = i8 + *m;
    i10 = i9 + kp1 * *m;
    i11 = i10 + *k * *m;
L30:
    if (! bul) {
	goto L40;
    }
    *h__ = hs;
    goto L100;
L40:
    if (jstart == 1) {
	imax0 = *imax;
    }
    h1 = *xk - x;
    if (abs(h1) > abs(*h__)) {
	goto L50;
    }
    hs = *h__;
    *h__ = h1;
    bul = TRUE_;
L50:
    de44d_c((U_fp)f, m, k, iniapr, &imax0, &jstart, &y[1], &x, &rab[1], &ay[
	    nxay * ay_dim1 + 1], &ady[nxady * ady_dim1 + 1], h__, &rab[i0], &
	    rab[i1], &rab[i2], &rab[i3], &rab[i4], &rab[i5], &rab[i6], &rab[
	    i7], &rab[i8], &rab[i9], &rab[i10], &rab[i11]);
    ++(*nx);
    xs[*nx + 1] = x;
    nxay += kp2;
    if (*iordy == 0) {
	goto L30;
    }
    if (*iordy != 1) {
	goto L100;
    }
    if (bul) {
	goto L30;
    }
    nxadyp = nxady;
    nxady += kp1;
    i__1 = kp1;
    for (j = 1; j <= i__1; ++j) {
	jtp = nxadyp - 1 + j;
	jt = nxady - 1 + j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
	    ady[l + jt * ady_dim1] = ady[l + jtp * ady_dim1];
/* L60: */
	}
/* L70: */
    }
    goto L30;
L100:
    return 0;
} /* de55d_c */
